=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class Track
    attr_accessor :address_from

    attr_accessor :address_to

    attr_accessor :carrier

    attr_accessor :eta

    attr_accessor :messages

    attr_accessor :metadata

    attr_accessor :original_eta

    attr_accessor :servicelevel

    attr_accessor :tracking_history

    attr_accessor :tracking_number

    attr_accessor :tracking_status

    attr_accessor :transaction

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'address_from' => :'address_from',
        :'address_to' => :'address_to',
        :'carrier' => :'carrier',
        :'eta' => :'eta',
        :'messages' => :'messages',
        :'metadata' => :'metadata',
        :'original_eta' => :'original_eta',
        :'servicelevel' => :'servicelevel',
        :'tracking_history' => :'tracking_history',
        :'tracking_number' => :'tracking_number',
        :'tracking_status' => :'tracking_status',
        :'transaction' => :'transaction'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'address_from' => :'Object',
        :'address_to' => :'Object',
        :'carrier' => :'Object',
        :'eta' => :'Object',
        :'messages' => :'Object',
        :'metadata' => :'Object',
        :'original_eta' => :'Object',
        :'servicelevel' => :'Object',
        :'tracking_history' => :'Object',
        :'tracking_number' => :'Object',
        :'tracking_status' => :'Object',
        :'transaction' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::Track` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::Track`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'address_from')
        self.address_from = attributes[:'address_from']
      end

      if attributes.key?(:'address_to')
        self.address_to = attributes[:'address_to']
      end

      if attributes.key?(:'carrier')
        self.carrier = attributes[:'carrier']
      end

      if attributes.key?(:'eta')
        self.eta = attributes[:'eta']
      end

      if attributes.key?(:'messages')
        if (value = attributes[:'messages']).is_a?(Array)
          self.messages = value
        end
      end

      if attributes.key?(:'metadata')
        self.metadata = attributes[:'metadata']
      end

      if attributes.key?(:'original_eta')
        self.original_eta = attributes[:'original_eta']
      end

      if attributes.key?(:'servicelevel')
        self.servicelevel = attributes[:'servicelevel']
      end

      if attributes.key?(:'tracking_history')
        if (value = attributes[:'tracking_history']).is_a?(Array)
          self.tracking_history = value
        end
      end

      if attributes.key?(:'tracking_number')
        self.tracking_number = attributes[:'tracking_number']
      end

      if attributes.key?(:'tracking_status')
        self.tracking_status = attributes[:'tracking_status']
      end

      if attributes.key?(:'transaction')
        self.transaction = attributes[:'transaction']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @address_from.nil?
        invalid_properties.push('invalid value for "address_from", address_from cannot be nil.')
      end

      if @address_to.nil?
        invalid_properties.push('invalid value for "address_to", address_to cannot be nil.')
      end

      if @carrier.nil?
        invalid_properties.push('invalid value for "carrier", carrier cannot be nil.')
      end

      if @eta.nil?
        invalid_properties.push('invalid value for "eta", eta cannot be nil.')
      end

      if @messages.nil?
        invalid_properties.push('invalid value for "messages", messages cannot be nil.')
      end

      if @original_eta.nil?
        invalid_properties.push('invalid value for "original_eta", original_eta cannot be nil.')
      end

      if @servicelevel.nil?
        invalid_properties.push('invalid value for "servicelevel", servicelevel cannot be nil.')
      end

      if @tracking_history.nil?
        invalid_properties.push('invalid value for "tracking_history", tracking_history cannot be nil.')
      end

      if @tracking_number.nil?
        invalid_properties.push('invalid value for "tracking_number", tracking_number cannot be nil.')
      end

      if @tracking_status.nil?
        invalid_properties.push('invalid value for "tracking_status", tracking_status cannot be nil.')
      end

      if @transaction.nil?
        invalid_properties.push('invalid value for "transaction", transaction cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @address_from.nil?
      return false if @address_to.nil?
      return false if @carrier.nil?
      return false if @eta.nil?
      return false if @messages.nil?
      return false if @original_eta.nil?
      return false if @servicelevel.nil?
      return false if @tracking_history.nil?
      return false if @tracking_number.nil?
      return false if @tracking_status.nil?
      return false if @transaction.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          address_from == o.address_from &&
          address_to == o.address_to &&
          carrier == o.carrier &&
          eta == o.eta &&
          messages == o.messages &&
          metadata == o.metadata &&
          original_eta == o.original_eta &&
          servicelevel == o.servicelevel &&
          tracking_history == o.tracking_history &&
          tracking_number == o.tracking_number &&
          tracking_status == o.tracking_status &&
          transaction == o.transaction
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [address_from, address_to, carrier, eta, messages, metadata, original_eta, servicelevel, tracking_history, tracking_number, tracking_status, transaction].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
